#include <string.h>
#include "crowbar.h"

CRB_ErrorDefinition crb_compile_error_message_format[] = {
    {"dummy", NULL},
    {"ʸˡ顼($(token)ն)", NULL},
    {"ʸ($(bad_char))", NULL},
    {"ؿ̾ʣƤޤ($(name))", NULL},
    {"ʥޥХʸǤ", NULL},
    {"ɽ˲ԤޤޤƤޤ", NULL},
    {"ɽޤ$(message)", NULL},
    {"곰Υ磻ʸǤ", NULL},
    {"ǤfinalˤϤǤޤ", NULL},
    {"ʣ黻ҤfinalФƤŬѤǤޤ", NULL},
    {"dummy"}
};

CRB_ErrorDefinition crb_runtime_error_message_format[] = {
    {"dummy", NULL},
    {"ѿޤϴؿĤޤ($(name))",
     "VariableNotFoundException"},
    {"ؿ׵᤹ФϤƤ¿ޤ",
     "ArgumentTooManyException"},
    {"ؿ׵᤹ФϤƤʤޤ",
     "ArgumentTooFewException"},
    {"ＰbooleanǤʤФʤޤ",
     "NotBooleanException"},
    {"ޥʥ黻ҤΥڥɤϿͷǤʤФʤޤ",
     "MinusOperandTypeException"},
    {"2黻$(operator)ΥڥɤηǤ",
     "BadOperandTypeException"},
    {"&&, ||黻ҤΥڥɤ˼¿ϻȤޤ",
     "LogicalOperatorDoubleOperandException"},
    {"&&, ||黻ҤΥڥɤϻȤޤ",
     "LogicalOperatorIntegerOperandException"},
    {"$(operator)黻ҤbooleanˤϻȤޤ",
     "NotBooleanOperatorException"},
    {"nullФŬѤǤ黻 ==  != Ǥ"
     "($(operator)ϤǤޤ)",
     "NotNullOperatorException"},
    {"ڥɤͤǤϤޤ",
     "NotLValueException"},
    {"ź黻ҤκڥɤǤϤޤ",
     "IndexOperandNotArrayException"},
    {"ź黻Ҥ椬ǤϤޤ",
     "IndexOperandNotIntException"},
    {"ϰϥСǤ"
     "$(size)[$(index)]򥢥Ƥޤ",
     "ArrayIndexOutOfBoundsException"},
    {"оݤΥ֥Ȥˤ$(method_name)Ȥ᥽åɤϤޤ",
     "NoSuchMethodException"},
    {"󥯥/ǥȤоݤǤϤޤ",
     "IncDecOperandTypeException"},
    {"󥯥/ǥȤоݤ¸ߤޤ",
     "IncDecOperandNotExistException"},
    {"ؿƤӽФоݤؿǤϤޤ",
     "NotFunctionException"},
    {"֥ȰʳΥФϹǤޤ",
     "NotObjectMemberUpdateException"},
    {"֥ȰʳΥФˤϤǤޤ",
     "NotObjectMemberAssignException"},
    {"Υ֥Ȥˤϥ$(member_name)Ϥޤ",
     "NoSuchMemberException"},
    {"ΥǡˤϥФϺΤȤޤ",
     "NoMemberTypeException"},
    {"ʸФ黻$(operator)ŬѤǤޤ",
     "BadOperatorForStringException"},
    {"ǽϤǤޤ",
     "DivisionByZeroException"},
    {"Хѿ$(name)¸ߤޤ",
     "GlobalVariableNotFoundException"},
    {"globalʸϴؿǤϻȤޤ",
     "GlobalStatementInToplevelException"},
    {"$(name)Ȥ̾δؿ¸ߤޤ",
     "FunctionExistsException"},
    {"resize()ΰǤʤФʤޤ"
     "($(type)ϤƤޤ)",
     "ArrayResizeArgumentException"},
    {"insert()1ǤʤФʤޤ"
     "($(type)ϤƤޤ)",
     "ArrayInsertArgumentException"},
    {"remove()ΰǤʤФʤޤ"
     "($(type)ϤƤޤ)",
     "ArrayRemoveArgumentException"},
    {"ʸΰֻ꤬ϰϳǤ"
     "Ĺ$(len)ʸФ$(pos)ꤷƤޤ",
     "StringPositionOutOfBoundsException"},
    {"ʸsubstr()2(ڤФʸĹ)ϰϳ($(len))Ǥ",
     "StringSubstrLengthException"},
    {"ʸsubstr()ΰǤʤФʤޤ"
     "($(type1)$(type2)ϤƤޤ)",
     "StringSubstrArgumentException"},
    {"㳰messageФޤ",
     "ExceptionHasNoMessageException"},
    {"㳰messageФʸǤϤޤ($(type)ϤƤޤ)",
     "ExceptionMessageIsNotStringException"},
    {"㳰stack_traceФޤ",
     "ExceptionHasNoStackTraceException"},
    {"㳰Υåȥ졼󷿤ǤϤޤ",
     "StackTraceIsNotArrayException"},
    {"㳰Υåȥ졼Ǥ֥ȤǤϤޤ",
     "StackTraceLineIsNotAssocException"},
    {"åȥ졼ιԤ˹ֹ椬ޤޤޤ",
     "StackTraceLineHasNoLineNumberException"},
    {"åȥ졼ιԤ˴ؿ̾ޤޤޤ",
     "StackTraceLineHasNoFuncNameException"},
    {"֥Ȱʳ㳰ȥåץ٥ޤŤޤ",
     "ExceptionIsNotAssocException"},
    {"㳰print_stack_traceФޤ",
     "ExceptionHasNoPrintStackTraceMethodException"},
    {"㳰print_stack_traceФǤϤޤ",
     "PrintStackTraceIsNotClosureException"},
    {"ʥޥХʸǤ",
     "BadMultibyteCharacterException"},
    {"㳰饹֥ȤǤϤޤ($(type)Ǥ)",
     "ExceptionClassIsNotAssocException"},
    {"㳰饹create methodޤ",
     "ExceptionClassHasNoCreateMethodException"},
    {"ؿ$(func_name)ϤƤ$(idx)ܤΰη㤤ޤ"
     "$(type)ϤƤޤ",
     "ArgumentTypeMismatchException"},
    {"곰Υ磻ʸǤ",
     "UnexpectedWideStringException"},
    {"ɽˤ븡˼Ԥޤ$(message)",
     "OnigSearchFailException"},
    {"ɽΥ롼ֹ椬礭ޤ",
     "GroupIndexOverflowException"},
    {"ꤵ줿롼ֹ(\\$(g_idx))б륰롼פϤޤ",
     "GroupIndexOverflowException"},
    {"breakޤcontinueޤreturnȥåץ٥ޤŤޤ",
     "BreakOrContinueReachedToplevelException"},
    {"ѿޤϥ$(name)finalǤ",
     "AssignToFinalVariableException"},
    {"ؿĤޤ($(name))",
     "FunctionNotFoundException"},
    {"dummy", NULL}
};

CRB_ErrorDefinition crb_native_error_message_format[] = {
    {"fopen()ؿˤϥեΥѥȥ⡼(ɤʸ)"
     "ϤƤ",
     "FOpenArgumentTypeException"},
    {"fclose()ؿˤϥեݥ󥿤ϤƤ",
     "FCloseArgumentTypeException"},
    {"fgets()ؿˤϥեݥ󥿤ϤƤ",
     "FGetsArgumentTypeException"},
    {"Υեϴ˥Ƥޤ",
     "FileAlreadyClosedException"},
    {"fputs()ؿˤϥեݥ󥿤ʸϤƤ",
     "FPutsArgumentTypeException"},
    {"new_array()ؿˤ(󥵥)ϤƤ",
     "NewArrayArgumentTypeException"},
    {"new_array()ؿˤϡΥ򼡸οϤƤ",
     "NewArrayArgumentTooFewException"},
    {"exit()ΰǤʤФʤޤ"
     "($(type)ϤƤޤ)",
     "ExitArgumentTypeException"},
    {"new_exception()ΰϥåʸǤ"
     "($(type)ϤƤޤ)",
     "NewExceptionArgumentException"},
    {"ʥޥХʸǤ",
     "FGetsBadMultibyteCharacterException"},
};
